svn commit: r286989 - user/pho/stress2/misc

Peter Holm pho at FreeBSD.org
Fri Aug 21 10:42:50 UTC 2015


Author: pho
Date: Fri Aug 21 10:42:49 2015
New Revision: 286989
URL: https://svnweb.freebsd.org/changeset/base/286989

Log:
  Added a "vm.overcommit" test scenario.
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/overcommit2.sh   (contents, props changed)

Added: user/pho/stress2/misc/overcommit2.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/overcommit2.sh	Fri Aug 21 10:42:49 2015	(r286989)
@@ -0,0 +1,69 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2014 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test vm.overcommit. Variation of overcommit.sh
+# Use a swap backed MD disk with the size of 1.2 * hw.usermem.
+# Deadlock seen: https://people.freebsd.org/~pho/stress/log/alan007.txt
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+[ `swapinfo | wc -l` -eq 1 ] && exit 0
+
+. ../default.cfg
+
+old=`sysctl -n vm.overcommit`
+[ $old -eq 1 ] && exit
+
+size=$((`sysctl -n hw.usermem` / 1024 / 1024))	# in MB
+size=$((size + size / 100 * 20))		# 120% of hw.usermem
+sysctl vm.overcommit=1
+
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -a -t swap -s ${size}m -u $mdstart
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+
+echo "Expect:
+/mnt: write failed, filesystem is full
+dd: /mnt/big.1: No space left on device"
+
+for i in `jot 10`; do
+	dd if=/dev/zero of=/mnt/big.$i bs=1m  2>&1 | \
+	    egrep -v "records|transferred" &
+done
+wait
+
+while mount | grep "on $mntpoint " | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+mdconfig -d -u $mdstart
+
+sysctl vm.overcommit=$old


More information about the svn-src-user mailing list